-1 Below are bd operands
501 scsize     | [Scan] Size of the adjustment.
502 rmrank     | Rank of the resolution matrix.
503 pc         | Current path correlation.
504 rmtr       | Trace of the resolution matrix.
505 obs        | Sample size for the current adjustment.
506 prmrank    | Rank of the partial resolution matrix.
507 size       | Size of the adjustment.
508 efree      | The number of definable elements remaining.
509 psize      | Size of the partial adjustment.
510 dfree      | The number of definable data values remaining.
511 prmtr      | Trace of the partial resolution matrix.
512 lasterror  | Last error number reported.
513 lasttype   | Indication of last adjustment deletion/addition.
514 adjhist    | Indication of the adjustment history.
515 eigrank    | [Invert/Eigen] Rank of matrix.
516 eigtr      | [Invert/Eigen] Trace of matrix.
517 scpsize    | [Scan]  Size of the partial adjustment.
518 scpc       | [Scan]  Path correlation.
519 pi         | The value of pi, correct to 11 decimal places.
520 mchannel   | The current macro channel number.
521 time       | Time in seconds since the start of the program.
522 selection  | Number of observations selected.
523 ochannel   | The current output channel number.
524 scurvar    | [Scan]  Unresolved uncertainty in a collection.
525 urand      | Uniform (0,1) pseudo-random number.
526 nrand      | Normal (0,1) pseudo-random number.
527 stores     | The number of belief stores available.
528 platform   | 0 for DOS, 1 for UNIX, 2 for DOS, 3 for WINDOWS.
529 mrmtr      | Trace of the maximal resolution matrix.
530 mrmrank    | Rank of the maximal resolution matrix.
531 priorvar   | Current belief store no. for prior variance matrix.
532 infovar    | Current belief store no. for information matrix.
533 betweenvar | Current belief store no. for between variance matrix.
534 modelvar   | Current belief store no. for model variance matrix.
535 rank       | Rank of the current adjustment prior variance matrix.
536 scptrace   | [Scan]  Partial resolved uncertainty in a collection.
537 dvsize     | Maximal discrepancy
538 dvpsize    | Maximal partial discrepancy
-2 Above are bd operands, below are bds operators
101 countb  | countb(N) The number of elements or bases in the base N.
102 ex      | ex(N) Expectation of N.
103 count   | count(N) The number of elements in the base N.
104 aex     | aex(N) Adjusted expectation for N.
105 number  | number(D) Number of observations on D.
106 mean    | mean(D) sample mean for D.
114 maxcase | maxcase(D) largest data case for D.
115 svar    | svar(D) sample variance for D.
117 countd  | countd(N) The number of data carriers in the base N.
118 real$   | real$(S) Check on type (real, integer, neither) of string S.
119 bn      | bn(N) 1 if N is a base name, 0 otherwise.
120 dn      | dn(N) 1 if N carries data, 0 otherwise.
121 en      | en(N) 1 if N is an element name, 0 otherwise.
122 empty$  | empty$(S) 0 or 1 according to whether string S is null.
123 len$    | len$(S) Length of string S.
125 ascl    | ascl(A) The scalar part of an assignment.
126 av      | av(N) Adjusted variance for N.
127 scav    | scav(N) [Scan] Adjusted variance for N.
128 arcin   | arcin(N) [Adjust, not noinfluence]  unc. reduction.
129 arcind  | arcind(N) [Adjust, not noinfluence] unc. reduction diagnostic.
130 arcout  | arcout(N) [Adjust, not noinfluence]  unc. reduction.
131 arcoutd | arcoutd(N) [Adjust, not noinfluence] unc. reduction diagnostic.
132 arcpc   | arcpc(N) [Adjust, not noinfluence]  path correlation.
134 scae    | scae(N) [Scan] Adjusted expectation for N.
135 countany| countany(N) The number of constituents in the base N.
220 ascf    | ascf(A,N) The coefficient of N in the assignment A.
221 ac      | ac(N1,N2) Adjusted covariance between N1 and N2.
222 match   | match(D1,D2) No. of cases where D1, D2 both have observations.
223 scov    | scov(D1,D2) Sample covariance between D1 and D2.
225 scorr   | scorr(D1,D2) Sample correlation between D1 and D2.
227 scac    | scac(N1,N2) [Scan] Adjusted covariance between N1, N2.
228 eq$     | eq$(S1,S2) 0 or 1 according as strings S1, S2 match.
229 neq$    | neq$(S1,S2) 0 or 1 according as strings S1, S2 don't match.
301 arctan  | arctan(x) Hyperbolic tangent.
302 sin     | sin(x) Sine.
303 cos     | cos(x) Cosine.
304 exp     | exp(x) e to the power x.
305 ln      | ln(x) natural logarithm.
306 trunc   | trunc(x) integer truncation.
307 cr      | cr(i) ith largest canonical resolution.
308 pcr     | pcr(i) ith largest partial canonical resolution.
309 sqr     | sqr(x) Square.
310 normal  | normal(x) Approximate area under Normal(0,1) to the left of x.
311 abs     | abs(x) absolute value.
312 sgn     | sgn(x) the sign of x.
313 sqrt    | sqrt(x) square root.
314 eig     | eig(i) [Invert/Eigen] ith ordered eigenvalue of matrix.
315 bcd1    | bcd1(i) ith eigenvalue for numerator vars, belief comparison.
316 bcd2    | bcd2(i) ith eigenvalue for denominator vars, belief comparison.
601 min     | min(X1,X2) the smaller of X1, X2.
602 max     | max(X1,X2) the larger of X1, X2.
700 var     | var(I,N1,N2) Covariance between N1 and N2.
701 corr    | corr(I,N1,N2) Correlation between N1 and N2.
1301 datain | datain(N,I) 0 or 1 according as observation I exists for N.
1303 centile| centile(D,R) Rth percentile for observations on D.
1304 rp     | rp(N,i) Resolution for N in direction i from resolution part.
1305 findsize | findsize(N,a) Sample size required for resolution a in N.
1306 resd   | resd(N,a) Resolution for sample size n in element N.
1307 vard   | vard(N,a) Adjusted variance for sample size n in element N.
1308 rvard  | rvard(N,a) Resolved variance for sample size n in element N.
-3  Above are BD operators, below are look arguments
1 a           | assignments.
2 b           | names of bases with their contents in order of introduction.
3 c           | constants (see also n).
4 d           | data.
5 e           | element names with their expectations.
6 for         | active for loops.
7 nc          | the settings of numeric controls.
8 program     | predefined program constants and limitations.
9 i           | current indices as defined by the index: command.
10 lall        | all labels on input channels. look:(j3) for ch. 3 only.
11 kept        | current retentions set by the keep: command.
12 l           | commented labels on input channels. look:(l3) for ch. 3 only.
13 $           | all possible look arguments.
14 f           | functions (see also c).
15 controls    | the settings of non-numeric controls.
16 fe          | functionally defined expectations.
17 operands    | a list of [B/D] operands usable within equations.
18 r           | correlations for all belief stores. r1 for store 1 only.
19 s           | active strings, the plot title; and the aid buffer.
20 options     | available output options.
21 fvar        | functionally defined beliefs. u2 for store 2 only.
22 v           | covariances for all belief stores. v2 for store 2 only.
23 grid        | grid coordinates and arc connections
24 files       | file assignments.
25 path        | search paths for input files.
26 commands    | [B/D] commands and their usage frequency.
27 dfstk       | DW ref - free data stack inspection.
28 operators   | a list of [B/D] operators usable within equations.
29 keep        | Keep command options
30 dstk        | DW ref - data storage details
-4  Above are possible look () arguments, below are options
1 ru          | Resolved uncertainty for a collection.
2 cd          | Canonical directions for the adjustment.
3 pathsum     | Summarise the paths of adjustments.
4 eigadd      | Matrix correction to ensure non-negative definiteness.
5 warn        | Output warnings and messages.
6 rm          | The resolution matrix.
7 bases       | Enable base titling for adjustments.
8 mcd         | Canonical directions for the maximal adjustment.
9 e           | Adjusted expectations.
10 v          | Variances for an adjustment.
11 pc         | Path correlation.
12 pcd        | Canonical directions for the partial adjustment.
13 a          | Observed adjusted expectations.
14 b          | The bearing.
15 pv         | Variances for a partial adjustment.
16 becorr     | Output of correlations between bearings and elements.
17 bcorr      | Output of correlations between bearings.
18 cda        | Observed adjusted expectations for canonical directions.
19 echo       | Echo commands to screen.
20 influence  | produce an influence diagram for an adjustment.
21 datawarn   | Give output associated with data inconsistency.
22 prm        | The partial resolution matrix.
23 connect    | Connect consecutive (x,y) points.
24 nopoints   | Do not plot actual points.
25 scov       | [Summary] Enable output of covariances in summaries.
26 b*         | Standardised bearing.
27 e*         | Standardised adjusted expectations.
28 mrm        | The maximal resolution matrix.
29 eig        | [Invert/Eigen] General output.
30 pcda       | Observed adjusted expectations for partial canon. directions.
31 scorr      | [Summary] Enable output of correlations in summaries.
32 all        | Switch on all output.
33 pcd*       | Standardised canonical directions for the partial adjustment.
34 plotnumber | Plot point collision marker.
35 mcda       | Observed adjusted expectations for maximal canon. directions.
36 msd        | Summarises the observed adjustment.
37 cd*        | Standardised canonical directions for the adjustment.
38 mcd*       | Standardised canonical directions for the maximal adjustment.
39 rp         | The resolution partition.
40 bcd        | Belief comparison directions.
41 lccd       | Covariances of original quantities with canonical directions.
42 dv         | The discrepancy vector.
43 dvecorr    | Correlations between discrepancy vectors and elements.
44 dvcorr     | Correlations between discrepancy vectors.
45 dv*        | Standardised discrepancy vector.
-5 Above are possible output options, below are controls
1 datawarn     | Only warn if data inconsistency found, else give error.
2 ac           | ac=i Store i for storing adjusted covariances.
3 scac         | scac=i [Scan] Store i for storing scanned adjusted covariances.
4 usedata      | Use data for the adjustment.
5 builddata    | Automatically construct data when building elements.
6 repeatmessage| Repeat message text as well as the message number if necessary.
7 pcarc        | pcarc=r min. correlation for arc drawn on partial corr. diag.
8 pcdiag       | display the partial correlation diagram.
9 plotxyy      | Controls whether multiple plots have one X or one Y (default).
10 autoselect   | Automatically select data as appropriate.
16 titles       | Enable general titling.
17 exchangeable | Force exploitation of exchangeable structures if possible.
18 overwrite    | Superimpose influence diagrams from separate adjustments.
19 arclength    | Arc length, in 0,1
20 prompt       | Produce a prompt when expecting keyboard input.
21 arcwidth     | Arc width, in 0,1
22 noinfluence  | During adjustments, obtain gains/losses for each entered base.
23 overshade    | Overshade node shadings from previous adjustments.
24 pcradius     | Radius for path and partial correlation circles.
25 overcolour   | overcolour=i. Give colour for node overshading.
26 autoarc      | autoarc=i. Automate arc style for influence diagrams.
27 winxsize     | winxsize=i set pixel size for x axis for windows graphics.
28 winysize     | winysize=i set pixel size for y axis for windows graphics.
29 cdradius     | radius for comparison diagram data change circles
30 cdscaler     | scaler for comparison diagram data change circles
31 matchcd      | ensure mean/predictive transforms match for exch. adjusts.
32 ae           | ae=i Store i for storing adjusted expectations.
33 scae         | scae=i [Scan] Store i for storing scanned adjusted expectations.
34 wheel        | Shade nodes as canonical wheels instead of as standard.
74 spokecolour  | spokecolour=i. Give colour for wheel diagnostic shading.
75 spokes       | spokes=i controls no. of spokes seen on canonical wheel
76 spokeshade   | spokeshade=R controls shading of spokes on canonical wheel
77 v            | v=i Use default variance store i
78 e            | e=i Use default expectation store i
79 xscale       | Controls x axis scale for plots
80 yscale       | Controls x axis scale for plots
81 xaxisdp      | Controls the number of dec. places for x axis tick values
82 yaxisdp      | Controls the number of dec. places for y axis tick values
83 smallshade   | Controls proportion of area shaded for node/arc diagnostics.
84 bigshade     | Controls proportion of area shaded for node/arc diagnostics.
85 plotcols     | Number of columns on low resolution plot.
86 plotlines    | Number of lines on low resolution plot.
87 rp           | rp=i No. of directions to contribute to resolution partition.
88 compare      | compare=i,j Set stores i,j as sources for belief comparison.
89 pcsource     | pcsource=i Set store i as source for partial corr. diagram.
90 missingsymb  | symbol to be plotted in case of a missing value
91 priorvar     | priorvar=i Set belief store i source for initial variances.
92 betweenvar   | betweenvar=i Set belief store i source for between variances.
93 infovar      | infovar=i Store i as source for model+residual variances.
94 dplaces      | dplaces=i Set the number of decimal places.
95 missing      | missing=i Set missing value to be i.
96 modelvar     | modelvar=i Store i source for model variances
97 obs          | obs=i Set sample size to be i when data is not available.
98 pcdest       | pcdest=i Set store i as destination for part. corr. diagram.
99 fwidth       | fwidth=i Set the width for output of real numbers.
-6 Above are controls, below are keep arguments
1 dv          | dv=A discrepancy vector as the assignment A.
2 b           | b=A Bearing as the assignment A.
3 pb          | pb=A Partial bearing as the assignment A.
4 e           | e=A Adjusted expectations as assignments with stem A.
5 itesize     | itesize=D Iterative adjustment expected sizes as data D.
6 itsize      | itsize=D Iterative adjustment sizes as data D.
7 itpath      | itpath=D Iterative adjustment path correlations as data D.
8 cd          | cd=A Canonical directions as assignments with stem A.
9 pcd         | pcd=A Partial canonical directions as assignments with stem A.
10 eig        | eig=A [Invert/Eigen] Eigenvectors as assignments with stem A.
12 log        | log=F Record screen output on file F.
13 fitted     | fitted=N Name of the fitted base as N.
14 history    | history=F Record keyboard input on the file F.
15 adjusted   | adjusted=N Name of the adjusted base as N.
16 bcd        | bcd=A Comparison eigenvectors as assignments with stem A.
17 av         | av=A adjusted versions as assignments with stem A.
18 rm         | raw resolution matrix columns
19 prm        | raw partial resolution matrix columns
20 mrm        | raw maximal resolution matrix columns
21 pdv        | pdv=A partial discrepancy vector as the assignment A.
-7 Above are arguments to the keep command, below are commands
1 var         | Specify variances and covariances.
2 f           | Define a function.
3 xelement    | Delete elements.
4 xbase       | Delete bases.
5 element     | Define elements.
6 testnnd     | Test non-negative-definiteness routine
7 eigen       | Determine the eigenstructure of a matrix.
8 option      | Set output options.
9 aid         | Define the aid buffer.
10 centre      | Centre beliefs.
11 base        | Define a base.
12 data        | Define data.
13 varysize    | Repeat an exchangeable adjustment for different sample sizes.
14 build       | Construct an element from others.
15 c           | Define a constant.
16 adjust      | Adjust one collection by another.
17 for         | Looping device.
18 end         | Ends for-statements.
19 fvar        | Declare functional variances and covariances.
20 m           | Move to subroutine or macro.
21 xfvar       | Delete functional variances and covariances.
22 ochannel    | Switch output channel.
23 endif       | End if-statement.
24 stop        | Stop program.
25 look        | Look at various quantities.
26 select      | Select data.
27 itadjust    | Perform an iterative adjustment.
28 lock        | Lock a belief store.
29 xindex      | Delete indices.
30 return      | Return from subroutine or macro.
31 xdata       | Delete data.
32 summary     | Summarise data.
33 findsize    | Find sample sizes in exchangeable situations.
36 print       | Print out results and text.
38 scan        | Scan the potential adjustment of one collection by another.
40 +           | Repeat last command.
41 show        | Display output.
42 datavec     | Generate vectors of data.
44 clearreturns| Clear the macro return stack.
45 onerror     | Define subroutine for handling errors.
46 loplot      | Low resolution plot.
47 string      | Define a string.
48 compare     | Compare belief specifications.
49 control     | Set controls.
50 goto        | Unconditional jump to another part of a macro.
51 gprint      | redraw last graphics screen to printer
52 xstring     | Delete strings.
53 if          | Conditional looping.
54 assign      | Declare assignments.
55 xassign     | Delete assignments.
56 index       | Define indices.
57 fe          | Declare functional expectations.
58 xfe         | Delete functional expectations.
59 clearch     | Close an input or output channel.
60 xc          | Delete constants.
61 invert      | Invert a matrix.
62 else        | Alternative in if-statement.
63 seed        | Seed for random number generator.
64 while       | Looping construct.
65 grid        | Define a grid for an influence diagram
66 cobuild     | Multivariable construction.
67 xf          | Delete functions.
68 refresh     | Refresh an input file following external alteration.
69 plot        | High resolution plot (loplot is the alternative).
70 export      | Export names, expectations, data, and variances.
71 coherence   | Check the coherence of belief specifications.
72 title       | Set the title for a plot.
73 factor      | Form specially structured data.
74 restart     | Restart the program.
75 clear       | Partially restart the program.
76 pause       | Wait until a key is pressed.
77 channel     | Define an input or output channel.
78 echannel    | Define the export channel.
79 testgrid    | Shows all defined nodes and arcs to aid design
80 keep        | Set the retention of miscellaneous quantities.
81 path        | Search paths for input files.
82 gclear      | Close graphics screen and return to text screen
83 matmult     | Multiply matrices.
84 readstring  | Define a string to to be input from the keyboard.
85 wend        | End while statement.
86 repeat      | Looping construct.
87 until       | End repeat statement.
88 e           | Define expectations.
89 ?           | Obtain help.
90 product     | Form a product of bases.
91 help        | Obtain help.
92 vardata     | Construct sample variance or correlation matrices.
93 xgrid       | Delete nodes from potential influence diagrams.
94 grid0       | Define grid for an influence diagram. No arc info.
95 arc         | Redefine an arc type between two nodes
96 ititle      | Set the title for an influence diagram.
97 pcdiag      | Partial correlation diagram.
98 pctitle     | Set the title for a partial correlation diagram.
99 gtext       | Output graphics text
100 indexvec   | Associate data vector with an index.
101 node       | Define node coordinates, colour, etc.
102 cdiag      | Draw a diagram to compare belief hypotheses
103 elock      | Lock an expectation store.
104 exp        | Define expectations
105 dlm        | Special command (DAW)
106 drawarc    | Draw nodes and connect with arc
107 line       | Draw line on a graph
108 save       | Save specifications
109 restore    | restore specifications
-8 Above are commands
eqns free.
fn 124,226,116,224 free.
fn 1302 is reserved for data carriers.
fn 230 is reserved for extended expectation operator, see also fn 102
fn 133 is reserved for default variance operator, see also fn 700, 701
fn 800,801 are reserved for extended variance operators, see also fn 700, 701
comm  35, (110 next free - change commtot).
opt free.

